SystemOrganization addCategory: #'GT-Metaceller-Tests'!

TestCase subclass: #GTMetacellerTestCase
	instanceVariableNames: 'testConfigurationClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

GTMetacellerTestCase subclass: #GTMetacellerConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:42'!
testChildren
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self assert: configuration children isEmpty! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:42'!
testMainProject
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self deny: configuration mainProject hasAttributes! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:42'!
testProjects
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self assert: configuration projects size equals: 3! !

!GTMetacellerConfigurationTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:50'!
testShortName
	| configuration |
	configuration := GTMetacellerConfiguration on: testConfigurationClass.
	self assert: configuration shortName equals: 'TestForMetaceller'! !

GTMetacellerTestCase subclass: #GTMetacellerPackageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testPlatformCommon
	| package |
	package := ((GTMetacellerConfiguration on: testConfigurationClass) mainProject version: '0.1') package: 'GT-Metaceller-Model'.
	self assert: package platforms size equals: 1.
	self assert: (package platforms contains: [ :each | each hasSymbol:#'common' ])! !

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testPlatformGemstone
	| package |
	package := ((GTMetacellerConfiguration on: testConfigurationClass) mainProject version: '0.1') package: 'GlamourCore'.
	self assert: package isNil! !

!GTMetacellerPackageTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:49'!
testPlatformPharo
	| package |
	package := ((GTMetacellerConfiguration on: testConfigurationClass) mainProject version: '0.1') package: 'GlamourTools'.
	self assert: package platforms size equals: 1.
	self assert: (package platforms includes: (GTPlatformDescription onSymbol: #'pharo'))! !

GTMetacellerTestCase subclass: #GTMetacellerProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Metaceller-Tests'!

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:53'!
testCreateVersion
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	(mainProject createSnapshotVersion: '0.2' baseline: '0.1-baseline').
	self assert: (testConfigurationClass includesSelector: #version02:)! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testGemstone
	| project version |
	project := GTMetacellerAtributedProject on: testConfigurationClass main: nil platform: (GTPlatformDescription onSymbol: #gemstone).
	version := project version: '0.1-baseline'.
	self assert: version packages size equals: 3.
	self assert: version projects size equals: 1! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testProjects
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject projects size equals: 3! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testSymbols
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject platformSymbols size equals: 3.
	self assert: (mainProject platformSymbols includes: #'common').
	self assert: (mainProject platformSymbols includes: #'gemstone').
	self assert: (mainProject platformSymbols includes: #'pharo').! !

!GTMetacellerProjectTest methodsFor: 'tests' stamp: 'DiegoLont 9/18/2013 15:44'!
testVersions
	| mainProject |
	mainProject := (GTMetacellerConfiguration on: testConfigurationClass) mainProject.
	self assert: mainProject versions size equals: 2.
	self assert: (mainProject versions contains: [ :each | each name  ='0.1-baseline' ]).
	self assert: (mainProject versions contains: [ :each | each name ='0.1' ])
! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 9/18/2013 16:02'!
createBaseline01
	testConfigurationClass
		compile: 'baseline01: aSpec
	<version: ''0.1-baseline''>
	aSpec for: #common do: [ 
		aSpec blessing: #''baseline''.
		aSpec description: ''Just a testDescription''.
		aSpec repository: ''http://smalltalkhub.com/mc/Moose/GToolkit/main''.

		aSpec package: ''GT-Metaceller-Model'';
			package: ''GT-Metaceller-Glamour'' with: [ 
				aSpec requires: #( ''GT-Metaceller-Model'' ) ];
			package: ''GT-Metaceller-Tests'' with: [ 
				aSpec requires: #( ''GT-Metaceller-Model'' ) ].
		aSpec
			group: ''Core'' with: #( ''GT-Metaceller-Model'' );
			group: ''Tests'' with: #( ''GT-Metaceller-Tests'' );
			group: ''Glamour'' with: #( ''GT-Metaceller-Glamour'' );
			group: ''All'' with: #( ''Tests'' ''Glamour'' ) ].
	
	aSpec for: #gemstone do: [ 
		aSpec project: ''GlamourCore'' with: [
				aSpec
					className: ''ConfigurationOfGlamour'';
					file: ''ConfigurationOfGlamour'';
					version: #development;
					loads: #(''Core'');
					repository: ''http://www.smalltalkhub.com/mc/Moose/Glamour/main'' ].
		aSpec package: ''GT-Metaceller-Glamour'' with: [ 
			aSpec requires: #( ''GlamourCore'' ) ] ].

	aSpec for: #pharo do: [ 
		aSpec project: ''GlamourTools'' with: [
				aSpec
					className: ''ConfigurationOfGToolkit'';
					file: ''ConfigurationOfGToolkit'';
					version: #development;
					loads: #( ''GT-Inspector'' );
					repository: ''http://www.smalltalkhub.com/mc/Moose/Glamour/main'' ].
		aSpec package: ''GT-Metaceller-Glamour'' with: [ 
			aSpec requires: #( ''GlamourTools'' ) ] ]' classified: 'baselines'.
	testConfigurationClass
		compile: 'development: spec
	<symbolicVersion: #development>
	spec for: #common version: ''0.1-baseline''' classified: 'symbolicVersions'.
	testConfigurationClass
		compile: 'version01: aSpec
	<version: ''0.1'' imports: #( ''0.1-baseline'')>
	aSpec for: #''common'' do: [ 
		aSpec blessing: #''development''.
		aSpec description: ''Just the development branch, so no version specified for now.''.
		aSpec author: ''Diego Lont'' ]' classified: 'versions'! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 9/18/2013 16:02'!
createTestConfigurationClass
	testConfigurationClass := Object
		subclass: #ConfigurationOfTestForMetaceller
		instanceVariableNames: 'project'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Snapshotcello-Tests'.
	testConfigurationClass class
		compile: 'project
	^self new project' classified: 'metacello'.
	testConfigurationClass class
		compile: 'ensureMetacello
	Smalltalk at: #MetacelloProject ifAbsent: [
		Gofer new
				url: ''http://seaside.gemtalksystems.com/ss/metacello/'';
				addPackage: ''ConfigurationOfMetacello'';
				load.
		(Smalltalk at: #ConfigurationOfMetacello) loadLatestVersion ]' classified: 'metacello'.
	testConfigurationClass class
		compile: 'isMetacelloConfig	
	^true'.
	testConfigurationClass 
		compile: 'project
	^ project ifNil: [ | constructor |
		self class ensureMetacello.
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project ]' classified: 'metacello'.
		! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 9/18/2013 15:41'!
setUp
	self createTestConfigurationClass.
	self createBaseline01.! !

!GTMetacellerTestCase methodsFor: 'setUp' stamp: 'DiegoLont 9/18/2013 15:26'!
tearDown
	testConfigurationClass removeFromSystem! !
